package me.Prometheus.DeGriefer;

import java.io.IOException;

import me.Prometheus.DeGriefer.DeGriefer;

import org.bukkit.event.Listener;
import org.bukkit.event.EventHandler;
import org.bukkit.event.EventPriority;
import org.bukkit.event.block.BlockBreakEvent;
import org.bukkit.event.block.BlockPlaceEvent;

public class DeGrieferListener implements Listener
{
	public static DeGriefer plugin;
	
	public DeGrieferListener(DeGriefer instance)
	{
		plugin = instance;
	}
	
	private void RemoveOwner(String s)
	{
		plugin.DataWorker.set(s, "");
		try
		{
			plugin.DataWorker.save(plugin.dgPath);
		}
		catch (IOException e1)
		{
			plugin.logger.info("Dear SysAdmin, there's an error. Chances are it's because write permissions are missing.");
		}
	}
	
	@EventHandler(priority = EventPriority.HIGH)
	public void onBlockBreak(BlockBreakEvent e)
	{
		if(plugin.Active == true)
		{
			String blockX = String.valueOf(e.getBlock().getX());
			String blockY = String.valueOf(e.getBlock().getY());
			String blockZ = String.valueOf(e.getBlock().getZ());
			String blockW = String.valueOf(e.getBlock().getWorld());
			String uID = blockW+blockX+blockY+blockZ;
			String listMode = plugin.ConfFile.getString("ListType");
			boolean autoDestroyBlock = false;
			if(plugin.DataWorker.contains(uID))
			{
				if(listMode.equalsIgnoreCase("blacklist"))
				{
					String pPlayer;
					for(int i = 0; i > plugin.dgPlayerList.size(); i++)
					{
						pPlayer = plugin.dgPlayerList.get(i);
						if(e.getPlayer().getName().equalsIgnoreCase(pPlayer))
						{
							RemoveOwner(uID);
							autoDestroyBlock = true;
						}
					}
				}
				if(listMode.equalsIgnoreCase("whitelist"))
				{
					String pPlayer = "";
					for(int i = 0; i > plugin.dgPlayerList.size(); i++)
					{
						pPlayer = plugin.dgPlayerList.get(i);
					}
					if(pPlayer == "")
					{
						RemoveOwner(uID);
						autoDestroyBlock = true;
					}
				}
				if(autoDestroyBlock == false)
				{
					if(e.getPlayer().getName().equalsIgnoreCase(plugin.DataWorker.getString(uID)) || e.getPlayer().hasPermission("degriefer.cankill"))
					{
						RemoveOwner(uID);
					}
					else
					{
						e.setCancelled(true);
					}
				}
			}
		}
	}
	
	private void AddOwner(String s, String p)
	{
		plugin.DataWorker.set(s, p);
		try
		{
			plugin.DataWorker.save(plugin.dgPath);
		}
		catch (IOException e1)
		{
			plugin.logger.info("Dear SysAdmin, there's an error. Chances are it's because write permissions are missing.");
		}
	}
	
	@EventHandler(priority = EventPriority.HIGH)
	public void onBlockPlace(BlockPlaceEvent e)
	{
		if(plugin.Active == true)
		{
			String blockX = String.valueOf(e.getBlock().getX());
			String blockY = String.valueOf(e.getBlock().getY());
			String blockZ = String.valueOf(e.getBlock().getZ());
			String blockW = String.valueOf(e.getBlock().getWorld());
			String uID = blockW+blockX+blockY+blockZ;
			String listMode = plugin.ConfFile.getString("ListType");
			//Creates a unique string ID for each block.
			if(listMode.equalsIgnoreCase("whitelist"))
			{
				String pPlayer;
				for(int i = 0; i > plugin.dgPlayerList.size(); i++)
				{
					pPlayer = plugin.dgPlayerList.get(i);
					if(e.getPlayer().getName().equalsIgnoreCase(pPlayer))
					{
						AddOwner(uID, e.getPlayer().getName().toLowerCase());
					}
				}
			}
			else
			{
				plugin.DataWorker.set(uID, e.getPlayer().getName().toLowerCase());
				try
				{
					plugin.DataWorker.save(plugin.dgPath);
				}
				catch (IOException e1)
				{
					plugin.logger.info("Dear SysAdmin, there's an error. Chances are it's because write permissions are missing.");
				}
			}
		}
	}
}
